--- old/usr/src/cmd/printf/printf.c	Thu May  8 09:00:23 2014
+++ new/usr/src/cmd/printf/printf.c	Thu May  8 09:00:23 2014
@@ -92,7 +92,7 @@
 main(int argc, char *argv[])
 {
 	size_t len;
-	int chopped, end, rval;
+	int end, rval;
 	char *format, *fmt, *start;
 
 	(void) setlocale(LC_ALL, "");
@@ -124,7 +124,7 @@
 	 * up the format string.
 	 */
 	fmt = format = *argv;
-	chopped = escape(fmt, 1, &len);		/* backslash interpretation */
+	(void) escape(fmt, 1, &len);	/* backslash interpretation */
 	rval = end = 0;
 	gargv = ++argv;
 
@@ -162,7 +162,7 @@
 			return (1);
 		}
 		(void) fwrite(start, 1, PTRDIFF(fmt, start), stdout);
-		if (chopped || !*gargv)
+		if (!*gargv)
 			return (rval);
 		/* Restart at the beginning of the format string. */
 		fmt = format;
@@ -338,13 +338,11 @@
 			return (NULL);
 		}
 		getout = escape(p, 0, &len);
-		*(fmt - 1) = 's';
-		PF(start, p);
-		*(fmt - 1) = 'b';
+		(void) fputs(p, stdout);
 		free(p);
 
 		if (getout)
-			return (fmt);
+			exit(*rval);
 		break;
 	}
 	case 'c': {
@@ -456,9 +454,13 @@
 			*store = '\b';
 			break;
 		case 'c':
-			*store = '\0';
-			*len = PTRDIFF(store, save);
-			return (1);
+			if (!percent) {
+				*store = '\0';
+				*len = PTRDIFF(store, save);
+				return (1);
+			}
+			*store = 'c';
+			break;
 		case 'f':		/* form-feed */
 			*store = '\f';
 			break;
